// prepreka
// s funkcijami za prepreko

#include <stdio.h>
#include <pthread.h>
#include <semaphore.h>
#include <Windows.h>

#define	NTHREADS	4
#define NPRINTS		5

int threads;
int shared;
pthread_barrier_t b;

void* barrier(void* arg) 
{
	int i;
	int myid = (int)arg;

	for(i=0; i<NPRINTS; i++)
	{
		if( myid == 0 )
			shared++;

		pthread_barrier_wait( &b );
		printf("%d %d\n", myid, shared );
	}

	return NULL;
}

int main(int argc, char *argv[]) 
{
	int i;
	pthread_t t[NTHREADS];

	shared = 0;
	threads = 0;

	pthread_barrier_init( &b, NULL, NTHREADS );

	for(i=0; i<NTHREADS; i++)
		pthread_create(&t[i], NULL, barrier, (void *)i);

	for(i=0; i<NTHREADS; i++)
		pthread_join(t[i], NULL);

	pthread_barrier_destroy( &b );

	return 0;
}
