// producer - consumer (osnova)

#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>

#define PRODUCERS       1
#define CONSUMERS       1
#define BUFFER_SIZE     1
#define TASKS           5

struct task 
{
    int id;
};

int buffer[BUFFER_SIZE];
int buffer_idx_put = 0;
int buffer_idx_get = 0;
int buffer_num;

void task_generate (int producerid, int taskid, struct task *t)
{
    t->id = 10 * producerid + taskid;
	printf ("P:%02d ", t->id);
	fflush (stdout);
}

void task_process (struct task *t)
{
	printf ("C:%02d ", t->id);
	fflush (stdout);
}

void buffer_put (struct task *t)
{
	buffer[buffer_idx_put] = t->id;
	buffer_idx_put = (buffer_idx_put+1) % BUFFER_SIZE;
	buffer_num++;
	printf("b%d ", buffer_num);
}

void buffer_get (struct task *t)
{
	t->id = buffer[buffer_idx_get];
	buffer_idx_get = (buffer_idx_get+1) % BUFFER_SIZE;
	buffer_num--;
	printf("b%d ", buffer_num);
}

void *producer(void *param)
{
	struct task t;

	for (int i = 0; i < TASKS; i++) 
    {
        // generate task
		task_generate (*((int *)param), i, &t);

		// put task to buffer
		buffer_put (&t);
	}
}

void *consumer(void *param)
{
	struct task t;

	while (1) 
    {
		// get task from buffer
		buffer_get (&t);

        // process task
		task_process (&t);
	}
}

int main (int argc, char *argv[])
{
	pthread_t tp[PRODUCERS];
    pthread_t tc[CONSUMERS];
	int tpid[PRODUCERS];
    
	for (int i=0; i<PRODUCERS; i++)
	{
		tpid[i] = i;
        pthread_create (&tp[i], NULL, producer, &tpid[i]);
	}

	for (int i=0; i<CONSUMERS; i++)
        pthread_create (&tc[i], NULL, consumer, NULL);

    for (int i=0; i<PRODUCERS; i++)
	    pthread_join (tp[i],NULL);

    printf("\n");
}
