// tokenizer: strtok pri razstavljanju niza uporablja statični kazalec, 
// ki kaže do kje v osnovnem nizu je funkcija prišla
// pri uprabi več niti, se ti dve statični kazalec povozita

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <pthread.h>

#define NTHREADS 2

struct params 
{
    int id;
    char *str;
};

void *Tokenizer(void *arg)
{
    struct params *p = (struct params *)arg;

    printf("%d> niz: %s\n", p->id, p->str);

    char *substring = strtok(p->str, " \t\n");
    
    int count = 0;
    while (substring != NULL)
    {
        count++;
        printf("%d> %d: %s\n", p->id, count, substring);
        substring = strtok(NULL, " \t\n");
    }

   return NULL;
}

int main(void)
{
    pthread_t t[NTHREADS];
    struct params p[NTHREADS];

    char * strings[] = {
        "test test test test test test test test test test", 
        "poskus poskus poskus poskus poskus poskus poskus poskus poskus poskus"};

    for (int i = 0; i < NTHREADS; i++)
    {
        p[i].id = i;
        p[i].str = strdup(strings[i]);
        pthread_create(&t[i], NULL, Tokenizer, &p[i]);
    }

    for (int i = 0; i < NTHREADS; i++)
    {     
        pthread_join(t[i], NULL);
        free(p[i].str);
    }

    return 0;
}